Unit Unit1;

Interface

Uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DAO_TLB,
    StdCtrls, Grids, Buttons, ExtCtrls, ComCtrls, ToolWin;

Type
    TfMain = Class(TForm)
        OpenDialog1: TOpenDialog;
    ToolBar1: TToolBar;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    ToolButton1: TToolButton;
    ComboBox1: TComboBox;
    ToolButton2: TToolButton;
    Button1: TButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    ToolButton3: TToolButton;
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    ProgressBar1: TProgressBar;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    pEdits: TPanel;
        Procedure FormCreate(Sender: TObject);
        Procedure BitBtn1Click(Sender: TObject);
        Procedure SpeedButton1Click(Sender: TObject);
        Procedure RefreshGrid;
        Procedure BuildEdits;
        Procedure ComboBox1Change(Sender: TObject);
        Procedure StringGrid1SelectCell(Sender: TObject; Col, Row: Integer;
            Var CanSelect: Boolean);
        Procedure Button1Click(Sender: TObject);
        Procedure SpeedButton2Click(Sender: TObject);
        Procedure SpeedButton3Click(Sender: TObject);
    Private
        { Private declarations }
    Public
        { Public declarations }
    End;
    
Var
    fMain            : TfMain;                 
    Engine           : DBEngine;               
    DB               : Database;               
    DaoTable         : Recordset;              
    DaoEdit          : Array[0..300] Of TEdit; 
    DaoLabel         : Array[0..300] Of TLabel;
    MaxLabelWidth    : Integer;                
    CurrentRow       : Integer;                
    //    DaoBookMark:PSafeArray;              
    
Implementation

{$R *.DFM}

Procedure TfMain.FormCreate(Sender: TObject);
Begin
    Engine := CoDBEngine.Create; //Init DaoEngine
End;

Procedure TfMain.BitBtn1Click(Sender: TObject);
Begin
    DaoTable.AddNew;
    DaoTable.Fields.Item[0].Value := '200';
    DaoTable.Fields.Item[1].Value := 'ZioBue';
    DaoTable.Update(1, False);
End;

Procedure TfMain.SpeedButton1Click(Sender: TObject);
Var
    J: Integer;
Begin
    If OpenDialog1.Execute = True Then
    Begin
        Edit1.Text := OpenDialog1.Filename;
        If DB <> Nil Then DB.CLOSE;
        DB := Engine.OpenDatabase(Edit1.Text, 0, False, ''); //Database Open
        (* Fill ComboBox Contents and select the first Table *)
        ComboBox1.Clear;
        For J := 0 To DB.TableDefs.Count - 1 Do // Iterate
        Begin
            If Copy(DB.TableDefs.Item[J].Name, 1, 4) <> 'MSys' Then //Hide System Tables
                ComboBox1.Items.Add(DB.TableDefs.Item[J].Name);
            ComboBox1.ItemIndex := 0;
        End; // for
        DaoTable := DB.OpenTable(ComboBox1.Text, dbOpenTable); //Then Open the first Table (recordset)
        RefreshGrid;
    End;
End;

Procedure TfMain.RefreshGrid;
Var
    J, j2: Integer;
Begin
    StringGrid1.ColCount := DaoTable.Fields.Count;
    StringGrid1.RowCount := DaoTable.RecordCount + 1;
    
    For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
    Begin
        StringGrid1.Cells[J, 0] := DaoTable.Fields.Item[J].Name;
    End;
    If DaoTable.RecordCount = 0 Then
    Begin
        StringGrid1.RowCount := 2;
        StringGrid1.FixedRows := 1;
        StringGrid1.Rows[1].Clear;
        exit;
    End;
    DaoTable.MoveFirst;
    ProgressBar1.MAX := DaoTable.RecordCount;
    ProgressBar1.Position := 0;
    For j2 := 1 To DaoTable.RecordCount Do // Iterate
    Begin
        For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
        Begin
            If DaoTable.Fields.Item[J].Value <> Null Then
                StringGrid1.Cells[J, j2] := DaoTable.Fields.Item[J].Value;
        End; // for
        DaoTable.MoveNext;
        ProgressBar1.Position := ProgressBar1.Position + 1;
    End; // for
End;

Procedure TfMain.BuildEdits;
Var
    J: Integer;
Begin
   MaxLabelWidth := 0; 
    For J := DaoTable.Fields.Count To 300 Do // Iterate
    Begin
        If DaoLabel[J] <> Nil Then
        Begin
            DaoLabel[J].Free;
            DaoLabel[J] := Nil;
        End;
        If DaoEdit[J] <> Nil Then
        Begin
            DaoEdit[J].Free;
            DaoEdit[J] := Nil;
        End;
    End; // for
    
    For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
    Begin
        If DaoLabel[J] = Nil Then DaoLabel[J] := TLabel.Create(fMain);
        With DaoLabel[J] Do
        Begin
            Left := 5;
            Top := (25 * J) + 8;
            CAPTION := DaoTable.Fields.Item[J].Name;
            Parent := pEdits;
            Refresh;
            If MaxLabelWidth < DaoLabel[J].Width Then MaxLabelWidth := DaoLabel[J].Width;
        End; // with
    End; // for
    
    For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
    Begin
        If DaoEdit[J] = Nil Then DaoEdit[J] := TEdit.Create(fMain);
        With DaoEdit[J] Do
        Begin
            Left := MaxLabelWidth + 15;
            Width := pEdits.Width - MaxLabelWidth - 25;
            Top := (25 * J) + 8;
            Parent := pEdits;
            Text := '';
        End; // with
    End;
    pEdits.Height := (DaoTable.Fields.Count * 25) + 8;
    
End;

Procedure TfMain.ComboBox1Change(Sender: TObject);
Begin
    If DaoTable <> Nil Then DaoTable.CLOSE;
    DaoTable := DB.OpenTable(ComboBox1.Text, dbOpenTable); //Table (recordset) Open
    RefreshGrid;
End;

Procedure TfMain.StringGrid1SelectCell(Sender: TObject; Col, Row: Integer;
        Var CanSelect: Boolean);
Var
    J: Integer;
Begin
    
    BuildEdits;
    If DaoTable.RecordCount = 0 Then exit;
    DaoTable.MoveFirst;
    For J := 1 To Row - 1 Do // Iterate
    Begin
        DaoTable.MoveNext;
    End; // for
    For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
    Begin
        If DaoTable.Fields.Item[J].Value <> Null Then
            DaoEdit[J].Text := DaoTable.Fields.Item[J].Value;
    End; // for
End;

Procedure TfMain.Button1Click(Sender: TObject);
Var
    J: Integer;
Begin
    DaoTable.Edit;
    For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
    Begin
        If DaoEdit[J].Text <> '' Then
            DaoTable.Fields.Item[J].Value := DaoEdit[J].Text;
    End; // for
    DaoTable.Update(1, False);
    RefreshGrid;
End;

Procedure TfMain.SpeedButton2Click(Sender: TObject);
Var
    J: Integer;
Begin
    For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
        DaoEdit[J].Text := '';
End;

Procedure TfMain.SpeedButton3Click(Sender: TObject);
Var
    J: Integer;
Begin
    DaoTable.AddNew;
    For J := 0 To DaoTable.Fields.Count - 1 Do // Iterate
    Begin
        If DaoEdit[J].Text <> '' Then
            DaoTable.Fields.Item[J].Value := DaoEdit[J].Text;
    End; // for
    DaoTable.Update(1, False);
    RefreshGrid;
End;

End.

